assume CS:code, DS:data

code segment
begin:

	mov ax, data		;data segment
	mov ds, ax		;pointer setting
	
	mov ax,0003h		;set screen mode
        int 10h			;clear screen

	mov ah, 09h
	lea dx, InpText		;adress of InpText -> dx
	int 21h			;output ASCII string
	
call Input			;first digit -> bl, second digit -> cl
		
	mov ax, 10		;row length of table
	mul bl			;vertical displacement
	mov bx, ax
	mov si,cx		;horizontal displacement
	
	mov al, [offset DecTab+bx+si]	;element of table

	mov cx, 4		;shift count
	mov ah,al		;AL copy
	shr ah, cl		;4 shifts right
	or ah, 30h		;AH + 30h
	and al, 0fh		;only least digit
	add al, '0'		;AL + 30h

	xchg ah, al		;digits order change
	mov result, ax		;result -> OutText
	
	mov ah, 09h
	lea dx, OutText		;adress of OutText -> dx
	int 21h			;output ASCII string
	
	jmp Finish
	
Input proc			;input decimal number
	
	mov dx, offset InpBuf	;begin of buffer
	mov ah, 10		;input ASCII string
	int 21h

	mov si, offset InpStr	;ASCII string pointer
	xor bx, bx		;BX=0
	xor cx, cx		;CX=0
	mov bl, [si]		;first byte
	mov digits, bl		;	   `-> OutText
	mov cl, [si+2]		;third byte
	mov digits+2, cl	;	   `-> OutText
	sub bl, 30h		;bl-30h - first digit
	and cl, 0fh		;cl-30h - second digit
	ret
Input endp

Finish:
	mov ax,4C00h		;finishing
	int 21h			;of program

code ends

data segment

InpBuf  db 16,0
InpStr  db '0123456789ABCDEF'	;Input ASCII string
InpText db 'Input your (N+32) number as 3*2: $'

OutText db 13,10
digits db '0*0 = '
result dw '00' 
OutEnd db '$'

DecTab:
row0 db 10 dup (0)
row1 db 0h,01h,02h,03h,04h,05h,06h,07h,08h,09h
row2 db 0h,02h,04h,06h,08h,10h,12h,14h,16h,18h
row3 db 0h,03h,06h,09h,12h,15h,18h,21h,24h,27h
row4 db 0h,04h,08h,12h,16h,20h,24h,28h,32h,36h
row5 db 0h,05h,10h,15h,20h,25h,30h,35h,40h,45h
row6 db 0h,06h,12h,18h,24h,30h,36h,42h,48h,54h
row7 db 0h,07h,14h,21h,28h,35h,42h,49h,56h,63h
row8 db 0h,08h,16h,24h,32h,40h,48h,56h,64h,72h
row9 db 0h,09h,18h,27h,36h,45h,54h,63h,72h,81h

data ends

end begin